[ VIGRA Homepage | Function Index | Class Index | Namespaces | File List | Main Page ]

ClusterImportanceVisitor Class Reference

`#include <vigra/random_forest/rf_algorithm.hxx>`

Inheritance diagram for ClusterImportanceVisitor:

## Public Member Functions

template<class RF , class PR , class SM , class ST >
void | after_tree_ip_impl (RF &rf, PR &pr, SM &sm, ST &, int index)
template<class RF , class PR , class SM , class ST >
void | visit_after_tree (RF &rf, PR &pr, SM &sm, ST &st, int index)
template<class RF , class PR >
void | visit_at_beginning (RF const &rf, PR const &)
template<class RF , class PR >
void | visit_at_end (RF &rf, PR &)
Public Member Functions inherited from VisitorBase
double | return_val ()
template<class Tree , class Split , class Region , class Feature_t , class Label_t >
void | visit_after_split (Tree &tree, Split &split, Region &parent, Region &leftChild, Region &rightChild, Feature_t &features, Label_t &labels)
template<class RF , class PR , class SM , class ST >
void | visit_after_tree (RF &rf, PR &pr, SM &sm, ST &st, int index)
template<class RF , class PR >
void | visit_at_beginning (RF const &rf, PR const &pr)
template<class RF , class PR >
void | visit_at_end (RF const &rf, PR const &pr)
template<class TR , class IntT , class TopT , class Feat >
void | visit_external_node (TR &tr, IntT index, TopT node_t, Feat &features)
template<class TR , class IntT , class TopT , class Feat >
void | visit_internal_node (TR &, IntT, TopT, Feat &)

## Public Attributes

MultiArray< 2, double > | cluster_importance_
MultiArray< 2, double > | cluster_stdev_
MultiArray< 2, int > | variables

## Detailed Description

calculate Cluster based permutation importance while learning. (RandomForestVisitor)

## Member Function Documentation

## ◆ visit_at_beginning()

template<class RF , class PR >

void visit_at_beginning | ( | RF const & | rf,
|  | PR const & |
| ) |  |

Allocate enough memory

## ◆ after_tree_ip_impl()

template<class RF , class PR , class SM , class ST >

void after_tree_ip_impl | ( | RF & | rf,
|  | PR & | pr,
|  | SM & | sm,
|  | ST & | ,
|  | int | index
| ) |  |

compute permutation based var imp. (Only an Array of size oob_sample_count x 1 is created.

- apposed to oob_sample_count x feature_count in the other method.

See also
  FieldProxy

## ◆ visit_after_tree()

template<class RF , class PR , class SM , class ST >

void visit_after_tree | ( | RF & | rf,
|  | PR & | pr,
|  | SM & | sm,
|  | ST & | st,
|  | int | index
| ) |  |

calculate permutation based impurity after every tree has been learned default behaviour is that this happens out of place. If you have very big data sets and want to avoid copying of data set the in_place_ flag to true.

## ◆ visit_at_end()

template<class RF , class PR >

void visit_at_end | ( | RF & | rf,
|  | PR & |
| ) |  |

Normalise variable importance after the number of trees is known.

## Member Data Documentation

## ◆ variables

MultiArray<2, int> variables

List of variables as produced by GetClusterVariables

## ◆ cluster_importance_

MultiArray<2, double> cluster_importance_

Corresponding importance measures

## ◆ cluster_stdev_

MultiArray<2, double> cluster_stdev_

Corresponding error

The documentation for this class was generated from the following file:

- vigra/random_forest/rf_algorithm.hxx

© Ullrich Köthe (ullrich.koethe@iwr.uni-heidelberg.de) Heidelberg Collaboratory for Image Processing, University of Heidelberg, Germany | html generated using doxygen and Python vigra 1.12.1